from System.Collections.Generic import List
from System import Byte, Int32
import sys
import common
#
# Set this to the exact name of your pick script .. capital matters
# and it has to be in your list of scripts on UI
#
BagOfHolding = 0x42292AD3
RuneBooks = [0x40278946, ]
#
# can have many entries seperated by a comma e.g. RuneBooks = [0x00001, 0x00002 ]
#
# Set for using Recall or SacredJourney
#
RecallAction = 4
SacredJourneyAction = 7
MovementAction = SacredJourneyAction    
#
AtlasGumpId = 878763590
MaxWeight = 520
ShovelID = 0x0F39
WaitForTarget = 5000
WaitAfterMining = 2000
WaitAfterPickAxe = 4000

PortableForge = 0
PortableForges = common.findRecursiveWithColor(Player.Backpack.Serial, [(0x0E32,  0x0489) ] )
if len(PortableForges) > 0:
    #Misc.SendMessage("Forges found")
    PortableForge = PortableForges[0]
#
IngotKey = 0
IngotKeys = common.findRecursiveWithColor(Player.Backpack.Serial, [(0x176B,  0x0014) ] )
if len(IngotKeys) > 0:
    #Misc.SendMessage("Ingot Key found")
    IngotKey = IngotKeys[0]
#
StoneKey = 0
StoneKeys = common.findRecursiveWithColor(Player.Backpack.Serial, [(0x176B,  0x0489) ] )
if len(StoneKeys) > 0:
    #Misc.SendMessage("Stone Key found")
    StoneKey = StoneKeys[0]
#
#
# Next keep track of position in book. At end of a book we'll set next book 
#
RuneOrder = range(100, 148, 1)
#
# First set which rune to use to 0 in case its not stored yet
# if its stored we'll use the stored value 
RuneIndexName = "Mining Rune Order"
RuneIndex = 0
RuneBookIndexName = "Mining RuneBook Order"
RuneBookIndex = 0
# 
#
MotionMap = {
             "North": (0, -1), 
             "Right": (+1, -1),
             "East": (+1, 0),
             "Down": (+1, +1),
             "South": (0, +1),
             "Left": (-1, +1),
             "West": (-1, 0),
             "Up": (-1, -1),             
             } 
RotateMap = {
             "North": "Right", 
             "Right": "East",
             "East": "Down",
             "Down": "South",
             "South": "Left",
             "Left": "West",
             "West": "Up",
             "Up": "North"
             } 
#
CaveTiles = [ 0xae, 0x5, 0x3, 0xc1, 0xc2, 0xc3, 0xbd, 0x0016, 0x0017, 0x0018, 0x0019, 0x245, 0x246, 0x247, 0x248, 0x249, 0x22b, 0x22c, 0x22d, 0x22e, 0x22f ]    
SoilTiles = [0x73, 0x74, 0x75, 0x76,  0x77, 0x78]
#             
def MineSpot():
    direction = Player.Direction
    x_delta, y_delta = MotionMap[direction]
    x = Player.Position.X + x_delta
    y = Player.Position.Y + y_delta
    xStart = Player.Position.X
    yStart = Player.Position.Y
    #
    Journal.Clear()
    retry = 0 
    Misc.SendMessage("Attempt to mine x: {} y: {}".format(x, y), 5)   
    land_id = Statics.GetLandID(x, y, Player.Map)
    for i in range(len(RotateMap)):
        if not Statics.GetLandFlag(land_id, "Impassable"):
            direction = RotateMap[direction]
            Misc.SendMessage("Try direction {}".format(direction))
            x_delta, y_delta = MotionMap[direction]
            x = Player.Position.X + x_delta
            y = Player.Position.Y + y_delta
            Misc.SendMessage("Attempt2 to mine x: {} y: {}".format(x, y), 5)
            xStart = Player.Position.X
            yStart = Player.Position.Y
            land_id = Statics.GetLandID(x, y, Player.Map)
    #            
    Misc.SendMessage("X: {} Y: {} LandID: 0x{:x} ImPassable: {}".format(x, y, land_id, Statics.GetLandFlag(land_id, "Impassable")))
    if Statics.GetLandFlag(land_id, "Impassable") or land_id in CaveTiles or land_id in SoilTiles:
        while True:
            if Player.Position.X != xStart:
                return
            if Player.Position.Y != yStart:
                return    
            if Journal.Search('There is no'):
                Player.HeadMessage(5, "DONE DONE")
                break
            if Journal.Search('no sand'):
                Player.HeadMessage(5, "DONE DONE")                
                break
            if Journal.Search('Target cannot be seen') or Journal.Search('You can\'t mine'):
                retry = retry + 1
                Misc.SendMessage("Retry: {} to find a mining spot".format(retry), 54)
                direction = RotateMap[direction]
                Misc.SendMessage("Try in the {} direction".format(direction), 54)
                x_delta, y_delta = MotionMap[direction]
                x = Player.Position.X + x_delta
                y = Player.Position.Y + y_delta
                Misc.SendMessage("Attempt3 to mine x: {} y: {}".format(x, y), 5)
                xStart = Player.Position.X
                yStart = Player.Position.Y
                #
                Journal.Clear()
                Misc.Pause(5000)
                if retry > 6:
                    break
            tileinfo = Statics.GetStaticsLandInfo(x, y, Player.Map)
            if Items.BackpackCount(0x0E86, 0) > 0:
                  Items.UseItemByID(0x0E86, -1)    
            else:    
                  Items.UseItemByID(ShovelID, -1) 
            Target.WaitForTarget(WaitForTarget, False)                    
            tiles = Statics.GetStaticsTileInfo(x, y, Player.Map)
            Misc.SendMessage("LandID: 0x{:x} #tiles{}".format(tileinfo.StaticID, len(tiles)), 5)
            if tileinfo.StaticID in CaveTiles and len(tiles) > 0:
                #Misc.SendMessage("StaticID: 0x{:x} #tiles{}".format(tiles[0].StaticID, len(tiles)), 5)
                Misc.SendMessage("Target x: {} y: {} z: {} tile# {}".format(x, y, tiles[0].StaticZ, tiles[0].StaticID), 44)
                Target.TargetExecute(x, y, tiles[0].StaticZ, tiles[0].StaticID)
            else:
                staticZ = Statics.GetLandZ(x, y, Player.Map)
                Target.TargetExecute(x, y, staticZ)
            Misc.Pause(WaitAfterMining)
            on_me_filter = Mobiles.Filter()
            on_me_filter.Enabled = True
            on_me_filter.RangeMin = -1
            on_me_filter.RangeMax = 2
            on_me_filter.Bodies = List[int] ( [ 0x006F ] )
            on_me_filter.Notorieties = List[Byte](bytes([3,4,5,6]))
            up_close_enemies = Mobiles.ApplyFilter(on_me_filter)
            if len(up_close_enemies) > 0:
                Player.HeadMessage(2, "STOPPING FOR AGRO")
                Stop()
            if Player.WarMode == True:
                Stop()    
            if Target.HasTarget(): 
                Target.Cancel()                    
                CheckWeight()    
#
MineSpot()             
